function [f, delta] = buildCircle(radius, w)
  [b, maxb, minb] = calcBorderWidth(radius);
  
  d = radius * 2 + 1;
  f = zeros(d, d);
  for i = 1:radius
    for j = 1:radius
      if (isInBorder(i, j, radius + 1, minb, maxb))
        f(i, j) = 1;
        f(i, 2 * radius - j + 2) = 1;
        f(2 * radius - i + 2, j) = 1;
        f(2 * radius - i + 2, 2 * radius - j + 2) = 1;
      endif
    endfor
    if (isInBorder(i, radius + 1, radius + 1, minb, maxb))
        f(i, radius + 1) = 1;
        f(2 * radius - i + 2, radius + 1) = 1;
      endif
  endfor
  for(i = 1:b)
    f(radius + 1, i) = 1;
    f(radius + 1, d + 1 - i) = 1;
  endfor
  delta = calculateDelta(radius, w);
%------------------------------------------------------------------------------------------------------------------------------  
function delta = calculateDelta(r, w)
  l = 2 * pi * r;
  %a =  0.86667;
  %a = 2;
  a = 0.053 * sqrt(w);
  %delta = l * 0.3;
  b =  6.8000;
  %b =  25;
  delta = a * r + b; 
end  
%------------------------------------------------------------------------------------------------------------------------------  
function [b, maxb, minb] = calcBorderWidth(r)
  b = max(int32(r / 5), 1);
  minb = r - int32(b/2);
  maxb = r + int32(b/2);
end  
%------------------------------------------------------------------------------------------------------------------------------  
function v = isInBorder(i, j, c, minb, maxb)
  dist = int32(sqrt((i - c)^2 + (j - c)^2));
  if (dist > minb && dist < maxb)
    v = true;
  else
    v = false;
  endif
end
%------------------------------------------------------------------------------------------------------------------------------
end