function [weight, frame, status] = findHand(name, last, result)
   xs = xe = ys = ye = -1;
   state = 0;
   c = [0, 0, 0];
   prev = zeros(1, 20);
   weight = [];
   frame = [];
   status = [];
   for i = 2:last
       filename = setstr([name, int2str(i), ".jpg"]);
       im = double(imread(filename) > 200);
       [m, x, y] = getMainLabel(im);
       if (state == 0 && m > 1000 && length(x) > 0 )
           state = 1;
           c = [1, 0, 0];
       elseif (state == 1 && m < prev(20))
           state = 3;
            c = [0, 1, 0];
       elseif (state == 2 && m < prev(5))
           state = 3;
            c = [0, 1, 0];
       elseif (state == 3 && m > prev(5))
           state = 2; 
           c = [0, 0, 1];	
       end
       if (state == 1)
       % train -> update xs, ys, xe, ye
       "train"
            [xs, xe, ys, ye] = getBound(im, x, y, m, xs, xe, ys, ye);
       elseif (state == 2)
      % change gesture -> update xs, ys
      "start gesture change"
           [xs, xe, ys, ye] = getBound(im, x, y, m, xs, xe, ys, ye);
           %ox = xe - xs;
           %oy = ye - ys;
           %[xs, xe, ys, ye] = updateBound(im, [xs, xe], [ys, ye], [nxs, nxe], [nys, nye]);
            %if (xe - xs != ox)
            %    "X was changed"
            %end
            %if (ye - ys != oy)
             %   "Y was changed"
            %end
       elseif (state == 3)
       "stabilized"
       % stabilized -> do nothing
       end
       [n0, n1] = size(im);
       newIm = zeros(n0, n1, 3);
       newIm(:, :, 1) = im;
       newIm(:, :, 2) = im;
       newIm(:, :, 3) = im;
       A = drawRectangle(newIm, xs, xe, ys, ye, c);
       %filename2 = setstr(["clust", int2str(i), ".jpg"]);
       filename2 = setstr([result, int2str(i), ".jpg"]);
       imwrite(A, filename2); 
       prev = shift(prev, 1);
       prev(1)= m;
       weight = [weight; m];
       frame = [frame; xs, xe, ys, ye];
       status = [status; state];
   end
%--------------------------------------------------------------------------
function [xs, xe, ys, ye] = updateBound(im, oldx, oldy, newx, newy)
    len = [oldx(2) - oldx(1), oldy(2) - oldy(1)];
	
    xc = ceil(sum(newx) / 2);
    yc = ceil(sum(newy) / 2);

    [n0, n1] = size(im);
    nxs = xc - floor(len(1) / 2);
    nxe = xc + ceil(len(1) / 2);
    if (nxs < 1)
        nxe += abs(1 - nxs);
    end
    if (nxe > n0)
        nxs -= abs(n0 - nxe);
    end
    xs = max(nxs, 1);
    xe = min(nxe, n0);
    
    nys = yc - floor(len(2) / 2);
    nye = yc + ceil(len(2) / 2);
    if (nys < 1)
        nye += abs(1 - nys);
    end
    if (nye > n1)
        nys -= abs(n0 - nye);
    end
    ys = max(nys, 1);
    ye = min(nye, n1);
end
%--------------------------------------------------------------------------
function [m, x, y] = getMainLabel(im)
     l = labelClusters(im);
     u = unique(l);
     len = length(u);
     s = zeros(1, len);
     for i = 2:len
         u1 = u(i);
         s(i) = sum(sum(l == u1));
     end
     
     [m, ind] = max(s);
     r = l == u(ind);
     
     [x, y] = find(r == 1);
end
%--------------------------------------------------------------------------
function [xs, xe, ys, ye] = getBound(im, x, y, m, xs, xe, ys, ye)
    if (m > 1000 && length(x) > 0)
            [n0, n1] = size(im);
            cx = 30; % 70
            cy = 30 ; % 10
            xs = max(min(x) - cx, 1);
            xe = min(max(x) + cx, n0);
            ys = max(min(y) - cy, 1);
            ye = min(max(y) + cy, n1);
    end
end
%--------------------------------------------------------------------------
function im = drawRectangle(im, xs, xe, ys, ye, c)
    if (xs != -1)
    im(xs, ys:ye, :) = ones(ye - ys + 1, 3) .* c;
    im(xe, ys:ye, :) = ones(ye - ys + 1, 3) .* c;
    im(xs:xe, ys, :) = ones(xe - xs + 1, 3) .* c;
    im(xs:xe, ye, :) = ones(xe - xs + 1, 3) .* c;
    end
end
%--------------------------------------------------------------------------
end