% GETFINGERFEATURES - return features for fingers: distance to the nearest "probably" finger and distance to hull
%
% Params:
%    im - image to processe
%
% Return:
%    d - features
%    h - list of "probably" fingers
%    v - visualize fingers
%------------------------------------------------------------------------
function [d, h, v] = getfingerfeatures(im)
  [k, x, y] = gethull(im);
    %hull = gethulllines(k, x, y);
  [h, A, v] = match_hough(im);
   r = get_radius(h);
  dist = fingerdistances(h, x(k), y(k));
  [m, n] = size(im);
  d1 = [dist, r'];
  d = d1;
  %d = (d1 ./ (m * n)) * (m + n) ^ 2;
  %d = [dist, r'] ./ (m * n);
%------------------------------------------------------------------------
function r = get_radius(h)
  r = zeros(1, length(h));
  for i = 1:length(h)
    item = h{i};
    r(i) = item(3);
  end
end  
%------------------------------------------------------------------------
function hull = gethulllines(k, x, y)
  n = length(k);
  ind = k(1);
  start = [x(ind), y(ind)];
  p1 = start;
  for i = 2:n
    ind = k(i);
    p2 = [x(ind), y(ind)];
    [a, b, c] = getline(p1, p2);
    hull{i - 1} = [a, b, c];
    p1 = p2;
  end
end
%------------------------------------------------------------------------
function [a, b, c] = getline(p1, p2)
  a = p1(2) - p2(2);
  b = p2(1) - p1(1);
  c = p1(1) * p2(2) - p2(1) * p1(2);
end
%------------------------------------------------------------------------
end
