% GETFINGERS - load finger theta from "theta_finger.txt" and return fingers
%
% Params:
%    im - image to processe
%
% Return:
%    coords - list of fingers
%    v - visualize fingers
%------------------------------------------------------------------------
function [coords, v] = getfingers(im)
  [d, h, v] = getfingerfeatures(im);
  load('theta_finger.txt');
  [p, percent] = predict(theta, d, 0.45);
  n = length(p);
  ind = 1;
  coords = [];
  for i = 1:n
    if p(i) == 1
      coords{ind} = h{i};
      ind++;
    end
  end
  if length(coords) > 0
    v = visualizing(im, coords);
  else 
    v = im;
  end
end
