% GETHULL - return hull for image
%
% Params:
%    im - image to processe
%
% Return:
%    [k, x, y] - hull params
%------------------------------------------------------------------------
function [k, x, y] = gethull(im)
  [edgelist, label] = edgelink(im, 10);
  [x, y] = createvect(edgelist);
  k = conv_hull (x, y);
%------------------------------------------------------------------------
function [x, y] = createvect(h)
  l = length(h);
  x = [];
  y = [];
  for i = 1:l
    [x1, y1] = createvect1(h, i);
    x = [x, x1];
    y = [y, y1];
  end
end
%------------------------------------------------------------------------
function [x, y] = createvect1(h, i)
  tmp = h{i};
  [l, m] = size(tmp);
  x = zeros(1, l);
  y = zeros(1, l);
  for i = 1:l
    x(i) = tmp(i, 1);
    y(i) = tmp(i, 2);
  end
end
%------------------------------------------------------------------------
end
