function  [features, weight, frame, status, ind, p] = main(name, last)
     [weight, frame, status] = prepareVideo(name, last);
     [ind, features] = extractPalmFeatures(name, 'processed/clust', weight, frame, status);
     p = predict(features);
     % if we want to train palm we sould call:
     %  [model, theta] = trainPalm(X, y);
%-----------------------------------------------------------------------------------------------------
function  [weight, frame, status] = prepareVideo(name, last)
    % remove backgroung from video
    % find mooving on the video
    multiProcessImages(name, last);
    [weight, frame, status] = findHand('processed/upd', last - 1);
end
%-----------------------------------------------------------------------------------------------------
function [ind, features] = extractPalmFeatures(original, processed, weight, frame, status)
    % extract features: width, height, phi moments
    [ind, features] = extractFeatures(original, processed, weight, frame, status, 2, 2, 9);
end
%-----------------------------------------------------------------------------------------------------
function p = predict(X)
    %load theta from 'theta.txt'
     load 'palm_theta.txt';
     % make predictions
     [svm, p] = predictPalm(X, model, theta);
end
%-----------------------------------------------------------------------------------------------------
function [precission, recall, percent] = calculateMetrics(p, Y)
    tp = sum((Y - p) == 0);
    fp = sum((Y - p) > 0);
    fn = sum((Y - p) < 0);
    
    precission = tp / (tp + fp);
    recall = tp / (tp + fn);
    percent = 100  - ((size(Y)) * 0.01 * sum((Y - p) == 0));
end
%-----------------------------------------------------------------------------------------------------
end