function [p, b, cur, x, y] = multiUpdateProcess(im, prev, p)
    B = prev(:);
	
    A = im(:);
    l = length(A);
    b = zeros(1, l);
    ind = zeros(1, l);
    tic
        % if (B(i) == 0)
            [p, cur, x, y] = updateProcess(A, p);
            %ind(i) = cur + (i - 1) * 5;
        %end
    toc
    b = classify(p, cur);
    b = medfilt2(reshape(b, size(im)));
%----------------------------------------------------------
function b = classify(p, cur)
    threshold = 0.9;
    p0 = p(1, :,  :);
    b = p0(cur) < threshold;
end
%----------------------------------------------------------
function [p, cur, x, y] = updateProcess(im, p)
    l = length(im);
    cur = zeros(1, l);
	
    w = p(1, :, :);
    mu = p(2, :, :);
    delta2 = p(3, :, :);
    c = repmat(im(:)', 5, 1);
    c = c(:);
        
    def = find(w != -1);
    ind = find(((mu(:) .- c(:)) ./delta2(:)) < 3);
    %ind = find(((mu .- c) ./delta2) < 3);
     indr = flipud(ind);
   [y, first, j] = unique (floor((indr .- 1) ./ 5));  %def(ind)
   first = indr(first);
   y = y + 1;
    if (length(first) > 0)
        % update process with ides: "first"
        newMu = updateMu(mu, c, first);
        newDelta2 = updateDelta2(delta2,c, newMu, first);
        p(2, :, :) = newMu;
        p(3, :, :) = newDelta2;
        
        newW = updateWeightFull(p, y, first);
        p(1, :, :) = newW;
        
        %cur(y) = mod(first, 5) + 1;
        cur(y) = first;
        
    end
    

    % create new processes for each except "y": setdiff (a, )
    x = setdiff(1:l, y);
    [p, cur2] = createNewProcess(p, im, x);
    
    cur(x) = cur2;
end
%----------------------------------------------------------
function [p, res] = createNewProcess(p, im, x)  
    res = zeros(1, length(x));
    for j = 1:length(x)
        i = x(j);
        % create new process
        w = p(1, :, i);
        l = length(find(w != -1));
        newMu = im(i);
        newDelta2 = 100;
        if (l < length(w))
            %add new process to the end
            cur = l + 1;
            p(1, cur, i) = 0;
            p(2, cur, i) = newMu;
            p(3, cur, i) = newDelta2;
            w = p(1, :, i);
            newW = updateWeight(w, cur, cur);
            p(1, :, i) = newW;
        else 
            % find process to remove
            [m, mind] = min(w);
            cur = mind;
            p(2, cur, i) = newMu;
            p(3, cur, i) = newDelta2;
        end
        res(j) = cur + i*5;
    end
end
%----------------------------------------------------------
function [p, cur] = createNewProcessMulti(p, im, x)
    % create new processes for each  "x"
    w = p(1, :, x);
    mu = p(2, :, x); 
    delta2 = p(3, :, x);
    c = repmat(im(x), 5, 1)(:);
    
    cur = zeros(1, length(x));
    newMu = c;
    newDelta2 = ones(1, length(delta2)) .* 100;
    
    def = find(w != -1);
    [y, first, j] = unique (ceil(def ./ 5));
    if (length(y) > 0)
        %add new process to the end
        cur(y) = first;
        w0 = p(1, :, x);
        w0(first) = zeros(1, length(first));
        p(1, :, x) = w0;
        newW = updateWeightFull2(p, x, first);
        p(1, :, x) = newW;
       [m1, m2, m3] = size(p(2, :, x)(first))
       size(newMu(first))
        p(2, :, x)(first) = reshape(newMu(first), m1, m2, m3);
        p(3, :, x)(first) = reshape(newDelta2(first), m1, m2, m3);
    end
    
    z = setdiff(x, y);
    if (length(z) > 0)
        % find process to remove
        [m, mind] = min(w);
        cur(z) = mind;
    end
end
%----------------------------------------------------------
function w = updateWeight(w, l, cur)
    a3 = 0.5;
    w(1:l) = (1 - a3) .* w(1:l);
    w(cur) += a3;
end
%----------------------------------------------------------
function w = updateWeightFull(p, x, cur)
    a3 = 0.1;
    p(1, :, x) = (1 - a3) .* p(1, :, x);
    w = p(1, :, :);
    w(cur) += a3;
end
%----------------------------------------------------------
function w = updateWeightFull2(p, x, cur)
    %a3 = 0.5;
    a3 = 0.95;
    p(1, :, x) = (1 - a3) .* p(1, :, x);
    w = p(1, :, x);
    w(cur) += a3;
end
%----------------------------------------------------------
function mu = updateMu(mu, c, ind)
    %a1 = 0.8;
    a1 = 0.95;
    mu(ind) = (1 - a1) .* mu(ind) + a1 .* c(ind);
end
%----------------------------------------------------------
function delta2 = updateDelta2(delta2, c, mu, ind)
    %a2 = 0.1;
    a2 = 0.05;
    t = c(ind) .- mu(ind);
    delta2(ind) = (1 - a2) .* delta2(ind) + a2 .* (t .^ 2);
end
%----------------------------------------------------------
end