% PREDICT - logistic regression predict function
%
% Params:
%    theta - param from function classifier
%    X - features
%    delta - predict threshold
% Result:
%    p - decission
%    percent - probability percent
%------------------------------------------------------------------------
function [p, percent] = predict(theta, X, delta)
  m = size(X, 1);
  p = zeros(m, 1);
  percent = zeros(m, 1);
  
  for iter = 1 : m
    x = X(iter, :);
    prob = sigmoid(x * theta);
    percent(iter) = prob;
    if prob >= delta 
      p(iter) = 1;
    else 
      p(iter) = 0;
    end
  end
%------------------------------------------------------------------------
function g = sigmoid(z)
  g = 1.0 ./ (1.0 + exp(-z));
end
%------------------------------------------------------------------------
end
