function [p, b] = updateProcesses(im, prev, p)
    [m, n] = size(im);
    b = zeros(m, n);
    tic
    for i = 1:m
       % i
        for j = 1:n
           % if (prev(i, j) == 0)
                [p, cur] = updateProcess(im, p, i, j);
                b(i, j) = classify(p, i, j, cur);
            %end
        end
    end
    toc
%----------------------------------------------------------
function b = classify(p, i, j, cur)
    threshold = 0.9;
    p0 = p(i, j, 1, cur);
    b = p0 < threshold;
end
%----------------------------------------------------------
function [p, cur] = updateProcess(im, p, i, j)
    w = p(i, j, 1, :);
    mu = p(i, j, 2, :);
    delta2 = p(i, j, 3, :);
    c = im(i, j);
    
        
    l = length(find(w != -1));
    if (c != mu(1:l))
        mu(1:l);
        c;
        delta2(1:l);
    end
    ind = find(((mu(1:l) .- c) ./delta2(1:l)) < 3);
    if (length(ind) > 0)
        % update ind(1) process
        cur = ind(1);
        newMu = updateMu(mu, l, c);
        newDelta2 = updateDelta2(delta2, l, c, newMu);
        newW = updateWeight(w, l, cur);
        p(i, j, 1, :) = newW;
        p(i, j, 2, :) = newMu;
        p(i, j, 3, :) = newDelta2;
    else
        % create new process
        newMu = c;
        newDelta2 = 100;
        if (l < length(w))
            %add new process to the end
            cur = l + 1;
            p(i, j, 1, cur) = 0;
            p(i, j, 2, cur) = newMu;
            p(i, j, 3, cur) = newDelta2;
            w = p(i, j, 1, :);
            newW = updateWeight(w, l, cur);
            p(i, j, 1, :) = newW;
        else 
            % find process to remove
            [m, mind] = min(w);
            p(i, j, 2, mind) = newMu;
            p(i, j, 3, mind) = newDelta2;
            cur = mind;
        end
    end
end
%----------------------------------------------------------
function w = updateWeight(w, l, cur)
    a3 = 0.5;
    w(1:l) = (1 - a3) .* w(1:l);
    w(cur) += a3;
end
%----------------------------------------------------------
function mu = updateMu(mu, l, c)
    a1 = 0.8;
    mu(1:l) = (1 - a1) .* mu(1:l) + a1 * c;
end
%----------------------------------------------------------
function delta2 = updateDelta2(delta2, l, c, mu)
    a2 = 0.5;
    t = c .- mu(1:l);
    delta2(1:l) = (1 - a2) .* delta2(1:l) + a2 * (t .^ 2);
end
%----------------------------------------------------------
end