% VISUALIZING - visualizing fingers
%
% Params:
%    im - image
%    coord - finger coordinates
%    h - diametr of circle
% Result:
%    v - visualize image
%------------------------------------------------------------------------
function v = visualizing(im, coord, h)
  l = length(coord);
  v = im;
  [n, m] = size(v);
  for i = 1:l
    tmp = coord{i};
    tmpl = length(tmp);
    if tmpl == 3
      %v = addrect(v, tmp(1), tmp(2), tmp(3),n, m);
      v = addcircle(v, tmp(1), tmp(2), n, m, tmp(3));
    else 
    %v = addpoint(v, tmp(1), tmp(2), h);
    v = addrect(v, tmp(1), tmp(2), h, n, m);
    end
  end
%------------------------------------------------------------------------
function v = addpoint(v, x, y, s) 
  s = 10;
  x -= int32(s/2);
  y -= int32(s/2);
  for i = 1:s
    for j = 1:s
      v(x + i, y + j) = 1;
    end
  end
end
%------------------------------------------------------------------------
function v = addcircle(v, x, y, n, m, r)
    r2 = r ^ 2;
    for q = 0:r
      p = int32(sqrt(r2-q^2));
      if x + p > 0 && x + p < n
        if y + q > 0 && y + q < m
          v(x + p, y + q) = 1;
        end
        if y - q > 0 && y - q < m
          v(x + p, y - q) = 1;
        end
      end
      if x - p > 0 && x - p < n
        if y + q > 0 && y + q < m
          v(x - p, y + q) = 1;
        end
        if y - q > 0 && y - q < m
          v(x - p, y - q) = 1;
        end
      end
    end
  %end
end
%------------------------------------------------------------------------
function v = addrect(v, x, y, s, n, m)
  s1 = int32(s/2);
  for i = 0:s1
    if x - s1 > 0
      if y - i > 0;
        v(x - s1, y - i) = 1;
      end
      if y + i < m
        v(x - s1, y + i) = 1;
      end
    end
    if x + s1 < n
      if y - i > 0;
        v(x + s1, y - i) = 1;
      end
      if y + i < m
        v(x + s1, y + i) = 1;
      end
    end
    %v(x - s1, y - i) = 1;
    %v(x - s1, y + i) = 1;
    %v(x + s1, y - i) = 1;
    %v(x + s1, y + i) = 1;

    if y - s1 > 0
      if x - i > 0;
        v(x - i, y - s1) = 1;
      end
      if x + i < m
        v(x + i, y - s1) = 1;
      end
    end
    if y + s1 < m
      if x - i > 0;
        v(x - i, y + s1) = 1;
      end
      if x + i < m
        v(x + i, y + s1) = 1;
      end
    end
    %v(x - i, y - s1) = 1;
    %v(x - i, y + s1) = 1;
    %v(x + i, y - s1) = 1;
    %v(x + i, y + s1) = 1;
  end
end
%------------------------------------------------------------------------
end
